## curl 7.52.1

=== debian/changelog ===
curl (7.52.1-4ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 09 Apr 2017 13:07:51 +0200

curl (7.52.1-4) unstable; urgency=medium

  * Fix regression in CONNECT response handling (Closes: #857613)
  * Fix buffer read overrun on --write-out as per CVE-2017-7407
    https://curl.haxx.se/docs/adv_20170403.html (Closes: #859500)

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 08 Apr 2017 21:55:27 +0100

curl (7.52.1-3ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Feb 2017 17:46:42 +0100

curl (7.52.1-3) unstable; urgency=high

  * Make SSL_VERIFYSTATUS work again as per CVE-2017-2629
    https://curl.haxx.se/docs/adv_20170222.html

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 21 Feb 2017 22:38:41 +0000

curl (7.52.1-2) unstable; urgency=medium

  * Fix HTTPS connection timeout with OpenSSL (Closes: #852317)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 29 Jan 2017 21:34:10 +0000

curl (7.52.1-1) unstable; urgency=medium

  * New upstream release
    - Fix printf floating point buffer overflow as per CVE-2016-9586
      (Closes: #848958)
  * B-D on "libssl1.0-dev | libssl-dev (<< 1.1)" (Closes: #850880, #844018)
  * Another attempt at making -dev packages multi-arch.
    Thanks to Benjamin Moody for the patches. (Closes: #731998, #846360)
  * Enable support for PSL (Closes: #847958)
  * Re-enable support for IDN (Closes: #849539)
  * Drop 10_disable-network-tests.patch.
    It didn't really work, and the issue is not urgent.
  * Switch curl binary back to libcurl3/OpenSSL.
    While the GnuTLS flavour mostly worked fine, there are a bunch of features
    that are not implemented.

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 12 Jan 2017 22:02:44 +0000

curl (7.51.0-1ubuntu1) zesty; urgency=medium

  * Merge from Debian. Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 16 Nov 2016 12:59:10 -0500

curl (7.51.0-1) unstable; urgency=medium

  * New upstream release
    - Fix cookie injection for other servers as per CVE-2016-8615
      https://curl.haxx.se/docs/adv_20161102A.html
    - Fix case insensitive password comparison as per CVE-2016-8616
      https://curl.haxx.se/docs/adv_20161102B.html
    - Fix OOB write via unchecked multiplication as per CVE-2016-8617
      https://curl.haxx.se/docs/adv_20161102C.html
    - Fix double-free in curl_maprintf as per CVE-2016-8618
      https://curl.haxx.se/docs/adv_20161102D.html
    - Fix double-free in krb5 code as per CVE-2016-8619
      https://curl.haxx.se/docs/adv_20161102E.html
    - Fix glob parser write/read out of bounds as per CVE-2016-8620
      https://curl.haxx.se/docs/adv_20161102F.html
    - Fix curl_getdate read out of bounds as per CVE-2016-8621
      https://curl.haxx.se/docs/adv_20161102G.html
    - Fix URL unescape heap overflow via integer truncation as per CVE-2016-8622
      https://curl.haxx.se/docs/adv_20161102H.html
    - Fix use-after-free via shared cookies as per CVE-2016-8623
      https://curl.haxx.se/docs/adv_20161102I.html
    - Fix invalid URL parsing with '#' as per CVE-2016-8624
      https://curl.haxx.se/docs/adv_20161102J.html
    - Fix IDNA 2003 makes curl use wrong host
      https://curl.haxx.se/docs/adv_20161102K.html
    - Fix escape and unescape integer overflows as
      per CVE-2016-7167 (Closes: #837945)
      https://curl.haxx.se/docs/adv_20160914.html
    - Fix incorrect reuse of client certificates (NSS backend)
      as per CVE-2016-7141 (Closes: #836918)
      https://curl.haxx.se/docs/adv_20160907.html
  * Drop 02_art_http_scripting.patch (file not shipped anymore)
  * Refresh patches
  * Temporarily disable IDN support
  * Don't install pdf and html docs (they are not shipped in the tarball anymore)
  * Install markdown docs

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 03 Nov 2016 22:46:14 +0000

curl (7.50.1-2) unstable; urgency=medium

  * Disable more network tests (Closes: #830273)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 28 Aug 2016 14:48:05 +0100

curl (7.50.1-1ubuntu2) zesty; urgency=medium

  * SECURITY UPDATE: Incorrect reuse of client certificates with NSS
    - debian/patches/CVE-2016-7141.patch: refuse previously loaded
      certificate from file in lib/vtls/nss.c.
    - CVE-2016-7141
  * SECURITY UPDATE: curl escape and unescape integer overflows
    - debian/patches/CVE-2016-7167.patch: deny negative string length
      inputs in lib/escape.c.
    - CVE-2016-7167
  * SECURITY UPDATE: cookie injection for other servers
    - debian/patches/CVE-2016-8615.patch: ignore lines that are too long in
      lib/cookie.c.
    - CVE-2016-8615
  * SECURITY UPDATE: case insensitive password comparison
    - debian/patches/CVE-2016-8616.patch: use case sensitive user/password
      comparisons in lib/url.c.
    - CVE-2016-8616
  * SECURITY UPDATE: OOB write via unchecked multiplication
    - debian/patches/CVE-2016-8617.patch: check for integer overflow on
      large input in lib/base64.c.
    - CVE-2016-8617
  * SECURITY UPDATE: double-free in curl_maprintf
    - debian/patches/CVE-2016-8618.patch: detect wrap-around when growing
      allocation in lib/mprintf.c.
    - CVE-2016-8618
  * SECURITY UPDATE: double-free in krb5 code


=== debian/control ===
Source: curl
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alessandro Ghedini <ghedo@debian.org>
Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>
Build-Depends: debhelper (>= 9.20141010~),
 autoconf,
 automake,
 ca-certificates,
 dpkg-dev (>= 1.17.14~),
 groff-base,
 libgnutls28-dev,
 libidn2-0-dev,
 libkrb5-dev,
 libldap2-dev,
 libnss3-dev,
 libpsl-dev,
 librtmp-dev (>= 2.4+20131018.git79459a2-3~),
 libssl1.0-dev | libssl-dev (<< 1.1),
 libtool,
 openssh-server <!nocheck>,
 python:native,
 quilt,
 stunnel4 <!nocheck>,
 zlib1g-dev
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/curl.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/curl.git
Homepage: http://curl.haxx.se

Package: curl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libcurl3 (= ${binary:Version})
Multi-Arch: foreign
Description: command line tool for transferring data with URL syntax
 curl is a command line tool for transferring data with URL syntax, supporting
 DICT, FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3,
 POP3S, RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 curl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP form
 based upload, proxies, cookies, user+password authentication (Basic, Digest,
 NTLM, Negotiate, kerberos...), file transfer resume, proxy tunneling and a
 busload of other useful tricks.

Package: libcurl3
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: easy-to-use client-side URL transfer library (OpenSSL flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 SSL support is provided by OpenSSL.

Package: libcurl3-gnutls
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: easy-to-use client-side URL transfer library (GnuTLS flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 SSL support is provided by GnuTLS.

Package: libcurl3-nss
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: easy-to-use client-side URL transfer library (NSS flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 SSL support is provided by NSS.

Package: libcurl4-openssl-dev
Architecture: any
Section: libdevel
Provides: libcurl-dev,
 libcurl-ssl-dev,
 libcurl3-openssl-dev,
 libcurl4-dev,
 libcurl3-dev
Conflicts: libcurl4-gnutls-dev, libcurl4-nss-dev
Depends: ${misc:Depends}, libcurl3 (= ${binary:Version})
Suggests: libcurl4-doc, libcurl3-dbg,
 libidn11-dev,
 libkrb5-dev,
 libldap2-dev,
 librtmp-dev,
 libssl1.0-dev | libssl-dev (<< 1.1),
 pkg-config,
 zlib1g-dev
Multi-Arch: same
Description: development files and documentation for libcurl (OpenSSL flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the development files (ie. includes, static library,
 manual pages) that allow one to build software which uses libcurl.
 .
 SSL support is provided by OpenSSL.

Package: libcurl4-gnutls-dev
Architecture: any
Section: libdevel
Provides: libcurl-dev,
 libcurl-ssl-dev,
 libcurl3-gnutls-dev,
 libcurl4-dev
Conflicts: libcurl4-openssl-dev, libcurl4-nss-dev
Depends: ${misc:Depends}, libcurl3-gnutls (= ${binary:Version})
Suggests: libcurl4-doc, libcurl3-dbg,
 libgnutls28-dev,
 libidn11-dev,
 libkrb5-dev,
 libldap2-dev,
 librtmp-dev,
 pkg-config,
 zlib1g-dev
Multi-Arch: same
Description: development files and documentation for libcurl (GnuTLS flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the development files (ie. includes, static library,
 manual pages) that allow one to build software which uses libcurl.
 .
 SSL support is provided by GnuTLS.

Package: libcurl4-nss-dev
Architecture: any
Section: libdevel
Provides: libcurl-dev,
 libcurl-ssl-dev,
 libcurl3-nss-dev,
 libcurl4-dev
Conflicts: libcurl4-openssl-dev, libcurl4-gnutls-dev
Depends: ${misc:Depends}, libcurl3-nss (= ${binary:Version})
Suggests: libcurl4-doc, libcurl3-dbg,
 libidn11-dev,
 libkrb5-dev,
 libldap2-dev,
 libnss3-dev,
 librtmp-dev,
 pkg-config,
 zlib1g-dev
Multi-Arch: same
Description: development files and documentation for libcurl (NSS flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the development files (ie. includes, static library,
 manual pages) that allow one to build software which uses libcurl.
 .
 SSL support is provided by NSS.

Package: libcurl3-dbg
Architecture: any
Section: debug
Priority: extra
Suggests: libc-dbg
Provides: libcurl4-dbg
Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}) | libcurl3-gnutls (= ${binary:Version}) | libcurl3-nss (= ${binary:Version})
Multi-Arch: same
Description: debugging symbols for libcurl (OpenSSL, GnuTLS and NSS flavours)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the debugging symbols of the OpenSSL, GnuTLS and NSS
 versions of libcurl3. It might be useful in debug sessions of software which
 uses libcurl.

Package: libcurl4-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: libcurl4-openssl-dev (<< 7.30.0-2),
 libcurl4-gnutls-dev (<< 7.30.0-2),
 libcurl4-nss-dev (<< 7.30.0-2)
Breaks: libcurl4-openssl-dev (<< 7.30.0-2),
 libcurl4-gnutls-dev (<< 7.30.0-2),
 libcurl4-nss-dev (<< 7.30.0-2)
Description: documentation for libcurl
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
 RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the documentation files for libcurl.

=== debian/rules ===
#! /usr/bin/make -f

# this will avoid unneded dependencies
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# this will catch miss-linking. (e.g. undefined symbols)
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

# enable all hardening options (see #763372)
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CONFIGURE_ARGS = -- --disable-dependency-tracking		\
	--disable-symbol-hiding --enable-versioned-symbols	\
	--enable-threaded-resolver --with-lber-lib=lber		\
	--with-gssapi=/usr					\
	--includedir=/usr/include/$(DEB_HOST_MULTIARCH)		\
	--with-zsh-functions-dir=/usr/share/zsh/vendor-completions

%:
	dh $@

override_dh_auto_configure:
	mkdir -p debian/build debian/build-gnutls debian/build-nss
	# pop the last patch (nss)
	quilt pop
	# pop the second last patch (gnutls)
	quilt pop
	# get the source without nss and gnutls patches
	tar -cf - --exclude=debian/build* --exclude=.pc . \
		| tar -xf - -C debian/build
	# push the second last patch which must be gnutls
	quilt push
	# get the source with gnutls patch applied
	tar -cf - --exclude=debian/build* --exclude=.pc . \
		| tar -xf - -C debian/build-gnutls
	# push the last patch which must be nss
	quilt push
	# get the source with nss patch applied
	tar -cf - --exclude=debian/build* --exclude=.pc . \
		| tar -xf - -C debian/build-nss
	# run buildconf and make sure to copy the patched ltmain.sh
	for flavour in build build-gnutls build-nss; do \
		(cd debian/$$flavour && ./buildconf && cp ../../ltmain.sh .) \
	done
	cd debian/build && dh_auto_configure ${CONFIGURE_ARGS}		\
		--with-ca-path=/etc/ssl/certs				\
		--with-ca-bundle=/etc/ssl/certs/ca-certificates.crt
	cd debian/build-gnutls &&  dh_auto_configure ${CONFIGURE_ARGS}	\
		--with-ca-path=/etc/ssl/certs				\
		--with-ca-bundle=/etc/ssl/certs/ca-certificates.crt	\
		--without-ssl --with-gnutls
	cd debian/build-nss && dh_auto_configure ${CONFIGURE_ARGS}	\
		--with-ca-bundle=/etc/ssl/certs/ca-certificates.crt	\
		--without-ssl --with-nss

override_dh_auto_build:
	cd debian/build && dh_auto_build
	cd debian/build-gnutls && dh_auto_build
	cd debian/build-nss && dh_auto_build

override_dh_auto_test:
	-cd debian/build && dh_auto_test
	-cd debian/build-gnutls && dh_auto_test
	-cd debian/build-nss && dh_auto_test

override_dh_install:
	${MAKE} -C debian/build					\
		DESTDIR=$(shell pwd)/debian/tmp install
	${MAKE} -C debian/build-gnutls				\
		DESTDIR=$(shell pwd)/debian/tmp-gnutls install
	${MAKE} -C debian/build-nss				\
		DESTDIR=$(shell pwd)/debian/tmp-nss install
	dh_install -plibcurl3-gnutls -plibcurl4-gnutls-dev	\
		--sourcedir=debian/tmp-gnutls
	dh_install -plibcurl3-nss -plibcurl4-nss-dev		\
		--sourcedir=debian/tmp-nss
	dh_install -pcurl -plibcurl3 -plibcurl4-openssl-dev -plibcurl4-doc \
		--sourcedir=debian/tmp
	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`
# Modify curl-config to make it architecture-independent:
# 1. In --static-libs output, replace the output of krb5-config (which
#    currently includes architecture-specific paths) with a call at
#    runtime to krb5-config.  Of course, this will only work correctly
#    if the installed libkrb5-dev matches the architecture of the
#    program you're linking, or if libkrb5-dev is made
#    multiarch-compatible at some point in the future.  For dynamic
#    linking this has no impact.
# 2. In --configure output, replace the architecture-specific paths
#    used for --libdir and --libexecdir with a literal backquoted call
#    to dpkg-architecture.  This is functionally equivalent to the way
#    debhelper actually invokes configure, and indicates to the user
#    (who runs curl-config --configure in order to learn about how the
#    library was compiled) that they are in fact using a multi-arch
#    package.
# 3. Likewise, replace the architecture name used for --build (and
#    build_alias) with a literal backquoted call to dpkg-architecture.
	sed -e "/-lcurl /s|`krb5-config --libs gssapi`|\`krb5-config --libs gssapi\`|" \
	    -e "/--prefix/s|/$(DEB_HOST_MULTIARCH)'|/'\\\\\`dpkg-architecture -qDEB_HOST_MULTIARCH\\\\\`|g" \
	    -e "/--prefix/s|=$(DEB_BUILD_GNU_TYPE)'|='\\\\\`dpkg-architecture -qDEB_BUILD_GNU_TYPE\\\\\`|g" \
	    -i `find . -name curl-config`

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_compress:
	dh_compress -X.pdf

override_dh_strip:
	dh_strip -plibcurl3 -plibcurl3-gnutls -plibcurl3-nss	\
		--dbg-package=libcurl3-dbg
	dh_strip --remaining-packages

override_dh_auto_clean:
	$(RM) -r debian/build* debian/tmp*
	dh_auto_clean

## curl 7.55.1

=== debian/changelog ===
curl (7.55.1-1ubuntu2) artful; urgency=medium

  * SECURITY UPDATE: FTP PWD response parser out of bounds read
    - debian/patches/CVE-2017-1000254.patch: zero terminate the entry path
      even on bad input in lib/ftp.c, added test to
      tests/data/Makefile.inc, tests/data/test1152.
    - CVE-2017-1000254

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 04 Oct 2017 08:35:10 -0400

curl (7.55.1-1ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Sep 2017 22:14:32 +0200

curl (7.55.1-1) unstable; urgency=medium

  * New upstream release
    - Fix FTBFS on powerpc (Closes: #872502)
  * Apply upstream patch to fix connection timeouts with NetworkManager
    (Closes: #873181)
  * Refresh patches
  * Bump Standards-Version to 4.1.0 (no changes needed)

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 02 Sep 2017 12:10:22 +0100

curl (7.55.0-1ubuntu2) artful; urgency=medium

  * debian/patches/0001-http-Don-t-wait-on-CONNECT-when-there-is-no-proxy.patch:
    Cherry-pick from upstream, via Arch: Don't wait for CONNECT. This fixes
    timeouts in network-manager's connectivity checker.

 -- Iain Lane <iain@orangesquash.org.uk>  Fri, 25 Aug 2017 10:46:14 +0100

curl (7.55.0-1ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Aug 2017 13:02:36 +0200

curl (7.55.0-1) unstable; urgency=medium

  * New upstream release
    - Fix TFTP sends more than buffer size as per CVE-2017-1000100
      (Closes: #871555)
    - Fix URL globbing out of bounds read as per CVE-2017-1000101
      (Closes: #871554)
  * Refresh patches and drop patches merged upstream
  * Update Standards-Version to 4.0.1 (no changes needed)
  * Drop -dbg package

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 12 Aug 2017 15:18:05 +0100

curl (7.52.1-5ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev, and libnghttp2-dev.
      + Drop libssh2-1-dev from binary package Depends.
      + debian/control: drop --with-nghttp2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 22 Apr 2017 14:54:52 +0200

curl (7.52.1-5) unstable; urgency=high

  * Fix TLS session resumption client cert bypass as per CVE-2017-7468
    https://curl.haxx.se/docs/adv_20170419.html

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 19 Apr 2017 11:19:50 +0100

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
  stunnel4 <!nocheck>,
  zlib1g-dev
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/curl.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/curl.git
 Homepage: http://curl.haxx.se
@@ -123,7 +123,7 @@
  libcurl3-dev
 Conflicts: libcurl4-gnutls-dev, libcurl4-nss-dev
 Depends: ${misc:Depends}, libcurl3 (= ${binary:Version})
-Suggests: libcurl4-doc, libcurl3-dbg,
+Suggests: libcurl4-doc,
  libidn11-dev,
  libkrb5-dev,
  libldap2-dev,
@@ -160,7 +160,7 @@
  libcurl4-dev
 Conflicts: libcurl4-openssl-dev, libcurl4-nss-dev
 Depends: ${misc:Depends}, libcurl3-gnutls (= ${binary:Version})
-Suggests: libcurl4-doc, libcurl3-dbg,
+Suggests: libcurl4-doc,
  libgnutls28-dev,
  libidn11-dev,
  libkrb5-dev,
@@ -197,7 +197,7 @@
  libcurl4-dev
 Conflicts: libcurl4-openssl-dev, libcurl4-gnutls-dev
 Depends: ${misc:Depends}, libcurl3-nss (= ${binary:Version})
-Suggests: libcurl4-doc, libcurl3-dbg,
+Suggests: libcurl4-doc,
  libidn11-dev,
  libkrb5-dev,
  libldap2-dev,
@@ -224,32 +224,6 @@
  manual pages) that allow one to build software which uses libcurl.
  .
  SSL support is provided by NSS.
-
-Package: libcurl3-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Suggests: libc-dbg
-Provides: libcurl4-dbg
-Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}) | libcurl3-gnutls (= ${binary:Version}) | libcurl3-nss (= ${binary:Version})
-Multi-Arch: same
-Description: debugging symbols for libcurl (OpenSSL, GnuTLS and NSS flavours)
- libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
- FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, LDAPS, POP3, POP3S,
- RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
- .
- libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
- form based upload, proxies, cookies, user+password authentication (Basic,
- Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
- and more!
- .
- libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
- fast, thoroughly documented and is already used by many known, big and
- successful companies and numerous applications.
- .
- This package provides the debugging symbols of the OpenSSL, GnuTLS and NSS
- versions of libcurl3. It might be useful in debug sessions of software which
- uses libcurl.
 
 Package: libcurl4-doc
 Section: doc

=== debian/rules ===
--- 
+++ 
@@ -108,11 +108,6 @@
 override_dh_compress:
 	dh_compress -X.pdf
 
-override_dh_strip:
-	dh_strip -plibcurl3 -plibcurl3-gnutls -plibcurl3-nss	\
-		--dbg-package=libcurl3-dbg
-	dh_strip --remaining-packages
-
 override_dh_auto_clean:
 	$(RM) -r debian/build* debian/tmp*
 	dh_auto_clean

## curl 7.58.0

=== src/CMakeLists.txt ===
set(EXE_NAME curl)

if(USE_MANUAL)
  # Use the C locale to ensure that only ASCII characters appear in the
  # embedded text. NROFF and MANOPT are set in the parent CMakeLists.txt
  add_custom_command(
    OUTPUT tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#include \"tool_setup.h\"" > tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#ifndef HAVE_LIBZ" >> tool_hugehelp.c
    COMMAND env LC_ALL=C "${NROFF}" ${NROFF_MANOPT}
            "${CURL_BINARY_DIR}/docs/curl.1" |
            "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl"
            "${CURL_SOURCE_DIR}/docs/MANUAL" >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#else" >> tool_hugehelp.c
    COMMAND env LC_ALL=C "${NROFF}" ${NROFF_MANOPT}
            "${CURL_BINARY_DIR}/docs/curl.1" |
            "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl" -c
            "${CURL_SOURCE_DIR}/docs/MANUAL" >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#endif /* HAVE_LIBZ */" >> tool_hugehelp.c
    DEPENDS
      "${CURL_SOURCE_DIR}/docs/MANUAL"
      generate-curl.1
      "${CURL_BINARY_DIR}/docs/curl.1"
      "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl"
      "${CMAKE_CURRENT_SOURCE_DIR}/tool_hugehelp.h"
    VERBATIM)
else()
  add_custom_command(
    OUTPUT tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "/* built-in manual is disabled, blank function */" > tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#include \"tool_hugehelp.h\"" >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "void hugehelp(void) {}" >> tool_hugehelp.c
    DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/tool_hugehelp.h"
    VERBATIM)

endif()

transform_makefile_inc("Makefile.inc" "${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake")
include(${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake)

if(MSVC)
  list(APPEND CURL_FILES curl.rc)
endif()

# CURL_FILES comes from Makefile.inc
add_executable(
  ${EXE_NAME}
  ${CURL_FILES}
  )

source_group("curlX source files" FILES ${CURLX_CFILES})
source_group("curl source files" FILES ${CURL_CFILES})
source_group("curl header files" FILES ${CURL_HFILES})

include_directories(
  ${CURL_SOURCE_DIR}/lib        # To be able to reach "curl_setup_once.h"
  ${CURL_BINARY_DIR}/lib        # To be able to reach "curl_config.h"
  ${CURL_BINARY_DIR}/include    # To be able to reach "curl/curl.h"
  # This is needed as tool_hugehelp.c is generated in the binary dir
  ${CURL_SOURCE_DIR}/src        # To be able to reach "tool_hugehelp.h"
  )

#Build curl executable
target_link_libraries( ${EXE_NAME} libcurl ${CURL_LIBS})

################################################################################

#SET_TARGET_PROPERTIES(${EXE_NAME} ARCHIVE_OUTPUT_DIRECTORY "blah blah blah")
#SET_TARGET_PROPERTIES(${EXE_NAME} RUNTIME_OUTPUT_DIRECTORY "blah blah blah")
#SET_TARGET_PROPERTIES(${EXE_NAME} LIBRARY_OUTPUT_DIRECTORY "blah blah blah")

# Add the postfix to the executable since it is not added automatically as for modules and shared libraries
set_target_properties(${EXE_NAME} PROPERTIES
  DEBUG_POSTFIX "${CMAKE_DEBUG_POSTFIX}")

#INCLUDE(ModuleInstall OPTIONAL)

install(TARGETS ${EXE_NAME} EXPORT curl-target DESTINATION bin)
export(TARGETS ${EXE_NAME}
       APPEND FILE ${PROJECT_BINARY_DIR}/curl-target.cmake
       NAMESPACE CURL::
)

install(EXPORT curl-target
        FILE curl-target.cmake
        NAMESPACE CURL::
        DESTINATION ${CURL_INSTALL_CMAKE_DIR}
)

=== tests/server/CMakeLists.txt ===
set(TARGET_LABEL_PREFIX "Test server ")

if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4127 /wd4306")
endif()

function(SETUP_EXECUTABLE TEST_NAME)    # ARGN are the files in the test
  add_executable( ${TEST_NAME} ${ARGN} )
  string(TOUPPER ${TEST_NAME} UPPER_TEST_NAME)

  include_directories(
    ${CURL_SOURCE_DIR}/lib      # To be able to reach "curl_setup_once.h"
    ${CURL_BINARY_DIR}/lib      # To be able to reach "curl_config.h"
    ${CURL_BINARY_DIR}/include  # To be able to reach "curl/curl.h"
    )
  if(USE_ARES)
    include_directories(${CARES_INCLUDE_DIR})
  endif()

  target_link_libraries(${TEST_NAME} ${CURL_LIBS})

  # Test servers simply are standalone programs that do not use libcurl
  # library.  For convinience and to ease portability of these servers,
  # some source code files from the libcurl subdirectory are also used
  # to build the servers.  In order to achieve proper linkage of these
  # files on Win32 targets it is necessary to build the test servers
  # with CURL_STATICLIB defined, independently of how libcurl is built.
  if(NOT CURL_STATICLIB)
    set_target_properties(${TEST_NAME} PROPERTIES
      COMPILE_DEFINITIONS CURL_STATICLIB)       # ${UPPER_TEST_NAME}
  endif()
  set_target_properties(${TEST_NAME} PROPERTIES
    PROJECT_LABEL "${TARGET_LABEL_PREFIX}${TEST_NAME}")

  # Add the postfix to the executable since it is not added
  # automatically as for modules and shared libraries
  set_target_properties(${TEST_NAME} PROPERTIES
    DEBUG_POSTFIX "${CMAKE_DEBUG_POSTFIX}")

endfunction()


transform_makefile_inc("Makefile.inc"
  "${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake")
include(${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake)

foreach(EXECUTABLE_NAME ${noinst_PROGRAMS})
  setup_executable(${EXECUTABLE_NAME} ${${EXECUTABLE_NAME}_SOURCES})
endforeach()


# SET(useful
# getpart.c getpart.h
# ${CURL_SOURCE_DIR}/lib/strequal.c
# ${CURL_SOURCE_DIR}/lib/base64.c
# ${CURL_SOURCE_DIR}/lib/mprintf.c
# ${CURL_SOURCE_DIR}/lib/memdebug.c
# ${CURL_SOURCE_DIR}/lib/timeval.c
# )

# SETUP_EXECUTABLE(sws sws.c util.c util.h ${useful})
# SETUP_EXECUTABLE(resolve resolve.c util.c util.h ${useful})
# SETUP_EXECUTABLE(sockfilt sockfilt.c util.c util.h ${useful} ${CURL_SOURCE_DIR}/lib/inet_pton.c)
# SETUP_EXECUTABLE(getpart testpart.c ${useful})
# SETUP_EXECUTABLE(tftpd tftpd.c util.c util.h ${useful} tftp.h)

=== debian/changelog ===
curl (7.58.0-2ubuntu3) bionic; urgency=medium

  * SECURITY UPDATE: FTP path trickery leads to NIL byte OOB write
    - debian/patches/CVE-2018-1000120.patch: reject path components with
      control codes in lib/ftp.c, add test to tests/*.
    - CVE-2018-1000120
  * SECURITY UPDATE: LDAP NULL pointer dereference
    - debian/patches/CVE-2018-1000121.patch: check ldap_get_attribute_ber()
      results for NULL before using in lib/openldap.c.
    - CVE-2018-1000121
  * SECURITY UPDATE: RTSP RTP buffer over-read
    - debian/patches/CVE-2018-1000122.patch: make sure excess reads don't
      go beyond buffer end in lib/transfer.c.
    - CVE-2018-1000122

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 15 Mar 2018 08:20:41 -0400

curl (7.58.0-2ubuntu2) bionic; urgency=medium

  * Build-depend on libssl-dev instead of libssl1.0-dev.
  * Rename libcurl3 to libcurl4, because libcurl exposes an SSL_CTX via
    CURLOPT_SSL_CTX_FUNCTION, and this object changes incompatibly between
    openssl 1.0 and openssl 1.1.
  * debian/patches/03_keep_symbols_compat.patch: drop, since we are no longer
    claiming compatibility.
  * debian/patches/90_gnutls.patch: Retain symbol versioning compatibility for
    non-OpenSSL builds.  Closes: #858398.

 -- Steve Langasek <steve.langasek@canonical.com>  Wed, 21 Feb 2018 08:21:31 -0800

curl (7.58.0-2ubuntu1) bionic; urgency=medium

  * Use an if statement to conditionally disable libssh2 in Ubuntu-only

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Jan 2018 10:19:32 +0100

curl (7.58.0-2) unstable; urgency=medium

  * Explicitly enable libssh2 support which got silently disabled in the
    previous update

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 24 Jan 2018 20:27:50 +0000

curl (7.58.0-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev.

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 24 Jan 2018 22:31:28 +0100

curl (7.58.0-1) unstable; urgency=medium

  * New upstream release
    - Fix HTTP/2 trailer out-of-bounds read as per CVE-2018-1000005
      https://curl.haxx.se/docs/adv_2018-824a.html
    - Fix HTTP authentication leak in redirects as per CVE-2018-1000007
      https://curl.haxx.se/docs/adv_2018-b3bf.html
  * Point Vcs-* to salsa.d.o
  * Bump Standards-Version to 4.1.3 (no changes needed)
  * Bump debhlper compat level to 11
  * Refresh patches
  * fix insecure-copyright-format-uri

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 24 Jan 2018 11:13:58 +0000

curl (7.57.0-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Drop dependencies not in main:
      + Build-Depends: Drop libssh2-1-dev.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Dec 2017 18:11:20 +0100

curl (7.57.0-1) unstable; urgency=medium

  * New upstream release
    - Fix NTLM buffer overflow via integer overflow as per CVE-2017-8816
      https://curl.haxx.se/docs/adv_2017-11e7.html
    - Fix FTP wildcard out of bounds read as per CVE-2017-8817
      https://curl.haxx.se/docs/adv_2017-ae72.html
    - Fix SSL out of buffer access as per CVE-2017-8818
      https://curl.haxx.se/docs/adv_2017-af0a.html
  * Remove -fdebug-prefix-map from curl-config.
    Thanks to Timo Weingärtner for the patch (Closes: #861974, #874223, #874238)
  * Don't install zsh completion when cross compiling.
    Thanks to Wookey for the patch (Closes: #812965)

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 30 Nov 2017 10:16:03 +0000

curl (7.56.1-1) unstable; urgency=medium

  * New upstream release
    - Fix IMAP FETCH response out of bounds read as per CVE-2017-1000257
      https://curl.haxx.se/docs/adv_20171023.html
  * Bump Standards-Version to 4.1.1 (no changes needed)
  * Drop 01_runtests_gdb.patch
  * Drop 12_dont-wait-on-CONNECT.patch
  * Refresh patches
  * Update *.symbols files
  * Use https:// URL in watch file

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 24 Oct 2017 11:05:48 +0100

curl (7.55.1-1ubuntu3) bionic; urgency=medium

  * SECURITY UPDATE: NTLM buffer overflow via integer overflow
    - debian/patches/CVE-2017-8816.patch: avoid integer overflow for malloc
      size in lib/curl_ntlm_core.c
    - CVE-2017-8816
  * SECURITY UPDATE: FTP wildcard out of bounds read
    - debian/patches/CVE-2017-8817.patch: fix heap buffer overflow in
      setcharset in lib/curl_fnmatch.c, added tests to
      tests/data/Makefile.inc, tests/data/test1163.
    - CVE-2017-8817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 29 Nov 2017 15:29:49 -0500

curl (7.55.1-1ubuntu2.1) artful-security; urgency=medium

  * SECURITY UPDATE: IMAP FETCH response out of bounds read
    - debian/patches/CVE-2017-1000257.patch: check size in lib/imap.c.
    - CVE-2017-1000257

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 20 Oct 2017 11:06:14 -0400

=== debian/control ===
--- 
+++ 
@@ -4,20 +4,23 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Alessandro Ghedini <ghedo@debian.org>
 Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>
-Build-Depends: debhelper (>= 9.20141010~),
+Build-Depends: debhelper (>= 11),
  autoconf,
  automake,
  ca-certificates,
+ dh-exec,
  dpkg-dev (>= 1.17.14~),
  groff-base,
  libgnutls28-dev,
  libidn2-0-dev,
  libkrb5-dev,
  libldap2-dev,
+ libnghttp2-dev,
  libnss3-dev,
  libpsl-dev,
  librtmp-dev (>= 2.4+20131018.git79459a2-3~),
- libssl1.0-dev | libssl-dev (<< 1.1),
+ libssh2-1-dev,
+ libssl-dev (>= 1.1),
  libtool,
  openssh-server <!nocheck>,
  python:native,
@@ -25,14 +28,14 @@
  stunnel4 <!nocheck>,
  zlib1g-dev
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 4.1.0
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/curl.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/curl.git
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/debian/curl.git
+Vcs-Browser: https://salsa.debian.org/debian/curl
 Homepage: http://curl.haxx.se
 
 Package: curl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libcurl3 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libcurl4 (= ${binary:Version})
 Multi-Arch: foreign
 Description: command line tool for transferring data with URL syntax
  curl is a command line tool for transferring data with URL syntax, supporting
@@ -44,12 +47,14 @@
  NTLM, Negotiate, kerberos...), file transfer resume, proxy tunneling and a
  busload of other useful tricks.
 
-Package: libcurl3
+Package: libcurl4
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: ca-certificates
 Pre-Depends: ${misc:Pre-Depends}
+Conflicts: libcurl3
+Replaces: libcurl3
 Multi-Arch: same
 Description: easy-to-use client-side URL transfer library (OpenSSL flavour)
  libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
@@ -121,14 +126,15 @@
  libcurl3-openssl-dev,
  libcurl4-dev,
  libcurl3-dev
-Conflicts: libcurl4-gnutls-dev, libcurl4-nss-dev
-Depends: ${misc:Depends}, libcurl3 (= ${binary:Version})
+Conflicts: libcurl4-gnutls-dev, libcurl4-nss-dev, libssl-dev (<< 1.1), libssl1.0-dev
+Depends: ${misc:Depends}, libcurl4 (= ${binary:Version})
 Suggests: libcurl4-doc,
  libidn11-dev,
  libkrb5-dev,
  libldap2-dev,
  librtmp-dev,
- libssl1.0-dev | libssl-dev (<< 1.1),
+ libssh2-1-dev,
+ libssl-dev (>= 1.1),
  pkg-config,
  zlib1g-dev
 Multi-Arch: same
@@ -166,6 +172,7 @@
  libkrb5-dev,
  libldap2-dev,
  librtmp-dev,
+ libssh2-1-dev,
  pkg-config,
  zlib1g-dev
 Multi-Arch: same
@@ -203,6 +210,7 @@
  libldap2-dev,
  libnss3-dev,
  librtmp-dev,
+ libssh2-1-dev,
  pkg-config,
  zlib1g-dev
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,13 @@
 CONFIGURE_ARGS = -- --disable-dependency-tracking		\
 	--disable-symbol-hiding --enable-versioned-symbols	\
 	--enable-threaded-resolver --with-lber-lib=lber		\
-	--with-gssapi=/usr					\
+	--with-gssapi=/usr --with-libssh2 --with-nghttp2	\
 	--includedir=/usr/include/$(DEB_HOST_MULTIARCH)		\
 	--with-zsh-functions-dir=/usr/share/zsh/vendor-completions
+
+ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
+	CONFIGURE_ARGS += --without-libssh2
+endif
 
 %:
 	dh $@
@@ -77,7 +81,7 @@
 		--sourcedir=debian/tmp-gnutls
 	dh_install -plibcurl3-nss -plibcurl4-nss-dev		\
 		--sourcedir=debian/tmp-nss
-	dh_install -pcurl -plibcurl3 -plibcurl4-openssl-dev -plibcurl4-doc \
+	dh_install -pcurl -plibcurl4 -plibcurl4-openssl-dev -plibcurl4-doc \
 		--sourcedir=debian/tmp
 	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`
 # Modify curl-config to make it architecture-independent:
@@ -97,9 +101,12 @@
 #    package.
 # 3. Likewise, replace the architecture name used for --build (and
 #    build_alias) with a literal backquoted call to dpkg-architecture.
+# 4. In --configure output, remove
+#    -fdebug-prefix-map=/buildd/specific/random/path=.
 	sed -e "/-lcurl /s|`krb5-config --libs gssapi`|\`krb5-config --libs gssapi\`|" \
 	    -e "/--prefix/s|/$(DEB_HOST_MULTIARCH)'|/'\\\\\`dpkg-architecture -qDEB_HOST_MULTIARCH\\\\\`|g" \
 	    -e "/--prefix/s|=$(DEB_BUILD_GNU_TYPE)'|='\\\\\`dpkg-architecture -qDEB_BUILD_GNU_TYPE\\\\\`|g" \
+	    -e "/-fdebug-prefix-map=/s|\(-fdebug-prefix-map=\)/[^ ]*=.||" \
 	    -i `find . -name curl-config`
 
 override_dh_installchangelogs:
